import math
import numpy as np

def DBF (ktask,t):
    	
	dbf=ktask['execution']*(math.floor((t-ktask['deadline'])/ktask['period'])+1)
	return max(0,dbf)
def F(Ltasks,t):
	f=0

	for iTask in Ltasks:
		#print len(Ltasks)
		#print "DBF:", DBF(iTask,t)
		f+=DBF(iTask,t)

	return f

def DBF_star(iTask,t,n,e):
	u=iTask['execution']/iTask['period']
	k=int(max(0,math.ceil(n*u/e-iTask['deadline']/iTask['period'])))
		
	if t<k*iTask['period']+iTask['deadline']:
		return DBF(iTask,t)/t
	else:
		return (iTask['execution']+(t-iTask['deadline'])*iTask['execution']/iTask['period'])/t



def LOAD_PTAS(tasks,M):
	e=0.1
	sumU=0
	for iTask in tasks:
		sumU+=iTask['execution']/iTask['period']
	sumLambda=0
	for iTask in tasks:
		sumLambda+=iTask['execution']/min(iTask['period'],iTask['deadline'])
	
	n=len(tasks)
	fmax=sumU+e
	times=[]
	if fmax>sumLambda:
		return sumLambda
	for iTask in tasks:
		u=iTask['execution']/iTask['period']
		k=int(max(0,math.ceil(n*u/e-iTask['deadline']/iTask['period'])))
		for j in xrange(k+1):
			t=iTask['period']*j+iTask['deadline']
			f=0
			for iTask in tasks:
				
				f+=DBF_star(iTask,t,n,e)

			if f>fmax:
				fmax=f
				if fmax >=sumLambda:
					return sumLambda
	

	return fmax
def LOADx(task,M):

	e=0.1
	lcm=task['period']
	for iTask in HPtasks:
		lcm*=iTask['period']
	c=task['execution']
	for iTask in HPtasks:
		c+=iTask['execution']

	sumU=task['execution']/task['period']
	for iTask in HPtasks:
		sumU+=iTask['execution']/iTask['period']
	maxpd=task['period']-task['deadline']
	for iTask in HPtasks:
		if maxpd<iTask['period']-iTask['deadline']:
			maxpd=iTask['period']-iTask['deadline']
	sumLambda=task['execution']/min(task['period'],task['deadline'])
	for iTask in HPtasks:
		sumLambda+=iTask['execution']/min(iTask['period'],iTask['deadline'])
	limit=min(lcm,c/e,maxpd*sumU/e)
	#print limit
	#limit=lcm
	#fmax=0
	tlist=[]
	fmax=sumU
	for iTask in HPtasks:
		j=0
		t=iTask['period']*j+iTask['deadline']
		while t<limit:
			t=iTask['period']*j+iTask['deadline']
			f=F(HPtasks,t)
			f+=DBF(task,t)
			f=f/itime
			if f>fmax:
				fmax=f
				limit=min(limit,sumU*maxpd/(fmax-sumU+e))
				if fmax>sumLambda-e:
					return fmax

	return fmax

def RB_LOAD(task,HPtasks,M):
	if len(HPtasks) == 0:
		return True
	L=[]
	for iTask in HPtasks:
		L.append(iTask)
	L.append(task)
	deltamax=0
	for iTask in L:
		d=iTask['execution']/min(iTask['period'],iTask['deadline'])
		if d>deltamax:
			deltamax=d
	fmax=LOAD_PTAS(L,M)
	mu=M-(M-1)*(task['execution']/min(task['period'],task['deadline']))
	
	#print "f",2*fmax+(math.ceil(mu)-1)*deltamax," 1:",2*fmax, " 2: ",(math.ceil(mu)-1)*deltamax, " mu: ",mu

	if 2*fmax+(math.ceil(mu)-1)*deltamax<mu:
		return True
	elif fmax<=(M-(M-1)*deltamax)/(1+2):
		return True
	else:
		return False 


def schedulable (taskset, processors):
    for prio, task in enumerate (taskset):
        if RB_LOAD (task, taskset[:prio], processors) is False:
            return False
    return True