import math
import numpy as np

def density(task):
    return float(task['execution'])/min(task['deadline'], task['period'])

def util(task):
    return float(task['execution'])/task['period']    

def u_sigma_k_max(task, hp_taskset):
    return max(max(map(lambda x : x['execution']/x['period'], hp_taskset) or [0]), float(task['execution'])/min(task['period'], task['deadline']) or [0])

def selector(task, hp_taskset):
    bUk = float(((task['deadline'] - task['period']))/task['period']) * float(task['execution']) / task['period']    
    sumu = sum (map(lambda item : item['execution'] * (1.0 - item['execution'] / item['period']) / task['period'], hp_taskset))
    return bUk - sumu > 0

def schedulable(taskset, processors):
    def schedulable(task, hp_taskset):
        if selector(task, hp_taskset):
            check = sum(map(lambda item : util(item), [task] + hp_taskset))
            if check > processors - (processors - 1) * u_sigma_k_max(task, hp_taskset):
                return False
        else:
            check = (float(task['execution'])/task['deadline']) + sum(map(lambda item : item['execution']*(1.0-item['execution']/item['period'])/task['deadline']+util(item), hp_taskset))
            if check > processors - (processors - 1) * u_sigma_k_max(task, hp_taskset):
                return False
        return True
    for prio, task in enumerate(taskset):
        if schedulable(task, taskset[:prio]) is False:
            return False
    return True
