import math
import numpy as np

def u_sigma_k_max(task, hp_taskset):
    return max(max(map(lambda x : x['execution']/x['period'], hp_taskset) or [0]), float(task['execution'])/min(task['period'], task['deadline']) or [0])

def density(task):
    return float(task['execution'])/min(task['deadline'], task['period'])

def util(task):
    return float(task['execution'])/task['period']    
    
def schedulable(taskset, processors):
    def schedulable(task, hp_taskset):        
        check = density (task) + sum(map(lambda item : (item['execution'] * (1.0 - util (item)) / task['deadline']) + util(item), hp_taskset))
        if check > processors - (processors - 1) * u_sigma_k_max(task, hp_taskset):
            return False
        return True
    
    for prio, task in enumerate(taskset):
        if schedulable(task, taskset[:prio]) is False:
            return False
    return True