import os
import sys
from matplotlib.backends.backend_pdf import PdfPages
from os import listdir
from os.path import isfile, join

sys.path.insert(0, '../../../')
import utility.plots as plots

def main ():
    i = 0
    k = 0
    results = [e for e in os.listdir('./') if e.endswith('.npy')]
    results = sorted(results, key = lambda handle : '_'.join(handle.split('_')[1:]))
    order = {'BAK' : 0, 'LOAD' : 1, 'HC' : 2, 'OUR-4.4' : 3, 'OUR-4.6' : 4, 'OUR-4.7' : 5, 'ALL' : 6}
    while results[i: i+7]:
        parameters = results[i: i+7][0].split('_')[1:-1]
        plot_results = sorted(results[i: i+7], key = lambda result : order[result.split('_')[0]])
        period = ('Periods %s-%s ms') % (parameters[3], parameters[4])
        deadlines = ('Deadlines %s Period - %s Period') % (parameters[6], parameters[7])
        processors = ('M = %s') % parameters[1]
        tasks = ('N = %s') % parameters[2]
        scheme = parameters[0]
        title = processors + ', ' + tasks + ', ' + scheme + ', ' + period + ', ' + deadlines
        name = ('plot_setting_%s') % k
        fig = plots.plot(title, plot_results)
        pp = PdfPages(name + '.pdf')
        pp.savefig(fig)
        pp.close()
        i += 7
        k += 1
 
    
if __name__ == "__main__":
    main()
